<?php
class clsCommon {
	function ErrorDisp($msg) {
		$html = new clsHeadFoot();
		$buff = "";
		$buff = $html->DrawHeadder("顼", "", "on");
		$buff .= $msg;
		print $buff;
		$html->DrawFooter("on");
		exit;
	}

	function ModifyCode($buff, $toDB, $force) {
		if ( $force == 1 ) {
			if ( $toDB ) { $buff = mb_convert_encoding($buff, DEF_DB_ENCODE, DEF_WEB_ENCODE); } else { $buff = mb_convert_encoding($buff, DEF_WEB_ENCODE, DEF_DB_ENCODE); }
		}
		return $buff;
	}

	function GetCFG($board) {
		global $CONFIG, $MenuData;
		$filename = "../".DEF_DAT_DIR."/".$board.".cfg";

		$ret = file_exists($filename);
		if ( $ret ) {
			if (!($fp = fopen($filename, "r"))) {
				$this->ErrorDisp("can't open $filename", $board);
			}
			while (!feof($fp)) {
				$buffer = trim(fgets($fp, 2048));
				$param = split("<>", $buffer);
				if ( isset($param[1]) ) {
					$CONFIG[$param[0]] = html_entity_decode($param[1], ENT_QUOTES);
				} else {
					$CONFIG[$param[0]] = "";
				}
			}
			fclose($fp);

			if (1 == $CONFIG['menu_use']){
				$pairs = split("<BR>", $CONFIG['menu_list']);
				foreach ($pairs as $buff) {
					$MenuData[] = $buff;	// ˥塼سǼ
				}
				array_pop($MenuData);		// Ǥ
			}
		} else {
			$this->ErrorDisp("not found $filename");
		}
		return;
	}

	function GetBoardInfo() {
		global $BOARDLIST, $CONFIG;

		$board_count = 0;

		$dh = opendir("../".DEF_DAT_DIR."/");
		while ($fdata = readdir($dh)) {
			$dir_list[] = $fdata;
		}
		closedir($dh);
		$board_cfg = preg_grep("/.cfg/i", $dir_list);
		sort( $board_cfg );
		$board_count = count($board_cfg);

		foreach ( $board_cfg as $val ) {
			$board = eregi_replace(".cfg", "", $val);
			$this->GetCFG($board);
			$BOARDLIST[$board] = $CONFIG['bbstitle'];
		}
		return $board_count;
	}

	function FormatName($name, $tag, $rank, $trip, $flag="off") {
		// EUCSJISѴ
		$name = $this->ModifyCode($name, False, DEF_CODE_MODIFY);
		$tag = $this->ModifyCode($tag, False, DEF_CODE_MODIFY);

		if ( $name == DEF_ADMIN_NAME ) {
			$name = "<FONT class=\"adm\">$name []</FONT>";
		} else {
			if ( $rank != 0 ) {
				if ( $rank == 2 ) {
					$name = "<FONT class=\"sysop\">$name [$tag]</FONT>";
				} else {
					if ( $tag != "" ) { $name = "<FONT class=\"tag\">$name [$tag]</FONT>";
					} else { $name = "<FONT class=\"grn\">$name</FONT>"; }
				}
			} else {
				if ( $trip != "" ) {
					$name = "<FONT class=\"trip\"><B>$name</B></FONT>";
				} else {
					if( $flag == "on" ) { $name = "<FONT class=\"lnk\"><B>$name</B></FONT>"; } else { $name = "$name"; }
				}
			}
		}
		return $name;
	}

	function FormatDateTime($atime, $flag) {
		$dow_list = array("","","","","","","");
		$dow_index = date("w", $atime);

		if (1 == $flag) {
			$DateStr = date("m/d", $atime);
		} else {
			$DateStr = date("Y/m/d", $atime);
		}
		$DateStr .= " (".$dow_list[$dow_index].") ";
		$DateStr .= date("H:i", $atime);

		return $DateStr;
	}

	function FormatComment($com, $name) {
		global $CONFIG;

		$com = $this->ModifyCode($com, False, DEF_CODE_MODIFY);
		$name = $this->ModifyCode($name, False, DEF_CODE_MODIFY);

		$com = "<P>$com</P>";

	    $com = ereg_replace("(^|>)(&gt;[^<]*)", "\\1<FONT COLOR=".$CONFIG['color_quote'].">\\2</font>", $com);
		$com = eregi_replace("(https?|ftp|news)(://[[:alnum:]\S\+\$\?\.%,!#~*/:@&=_-]+)","<a href=\"\\1\\2\" target=\"_blank\">\\1\\2</a>", $com);
		if ( $name == DEF_ADMIN_NAME ) {
		    $com = eregi_replace("(&lt;B&gt;)", "<B>", $com);
		    $com = eregi_replace("(&lt;\/B&gt;)", "</B>", $com);
		    $com = eregi_replace("(&lt;U&gt;)", "<U>", $com);
		    $com = eregi_replace("(&lt;\/U&gt;)", "</U>", $com);
		    $com = eregi_replace("(&lt;UL&gt;)", "<UL>", $com);
		    $com = eregi_replace("(&lt;\/UL&gt;)", "</UL>", $com);
		    $com = eregi_replace("(&lt;LI&gt;)", "<LI>", $com);
		    $com = eregi_replace("(&lt;\/LI&gt;)", "</LI>", $com);
		    $com = eregi_replace("(&lt;EM&gt;)", "<EM>", $com);
		    $com = eregi_replace("(&lt;\/EM&gt;)", "</EM>", $com);
		}

		return $com;
	}

	function GetJoinData($db, $pdb, $board, $num) {
		global $TopicData, $ReplyData;

		$ReplyData = array();

		$SQL_query = "SELECT * from ".DEF_PRE_TABLE.$board."_topic WHERE i_MainID = ".$num;
		$db->Query($SQL_query, $result);
		$row = $pdb->DB_fetch_assoc($result);

		$TopicData = $row;
		$SQL_query = "SELECT * from ".DEF_PRE_TABLE.$board."_reply WHERE i_MainID = $num ORDER BY i_ReplyDate";
		$db->Query($SQL_query, $result);
		while ($row = $pdb->DB_fetch_assoc($result)) {
			$ReplyData[] = $row['i_subid']."<>".$row['i_mainid']."<>".$row['i_replydate']."<>".$row['name']."<>".$row['tagname']."<>".$row['i_rank']."<>".$row['email']."<>".$row['url']."<>".$row['icq']."<>".$row['ip']."<>".$row['pwd']."<>".$row['comment']."<>".$row['remote_host']."<>".$row['i_flag']."<>".$row['i_uid']."<>".$row['tripid']."<>".$row['i_update']."<>".$row['upname'];
		}
	}

	function FixCheck($db, $pdb, $fname, $pass) {
		$fname = preg_replace("/'/", "\\'", $fname);
		$SQL_query = "SELECT * FROM ".DEF_UNIQUE_TABLE." WHERE HName='".$fname."'";
		$db->Query($SQL_query, $result1);
		$cnt = $pdb->DB_num_rows($result1);
		$row1 = $pdb->DB_fetch_assoc($result1);
		if ( $cnt != 0 ) {
			$SQL_query = "SELECT * FROM ".DEF_UNIQUE_TABLE." WHERE HName='".$fname."' AND PWD='".$pass."'";
			$db->Query($SQL_query, $result2);
			$row2 = $pdb->DB_fetch_assoc($result2);
			if ( $pass != $row2['pwd'] ) { return $row1; } else { return $row2; }
		} else {
			return $row1;
		}
	}

	function DrawNavi($targ_php, $board, $page, $cmd="") {
		global $cmd, $view_count;
		global $pwd, $sid;

		$t_list		= 1;
		$buff		= "";

		$pdb	= new clsPipeDB();
		$db		= $pdb->DB_Connect();
		$SQL_query = "SELECT i_MainID FROM ".DEF_PRE_TABLE.$board."_topic";
		if ( $cmd != "" ) {
			if ( $cmd == "fin" )		{ $SQL_query .= " WHERE i_Flag = 0";
			} else if ( $cmd == "rev" )	{ $SQL_query .= " WHERE i_Flag = 1"; }
		} else {
			$SQL_query .= " WHERE i_Flag != 2";
		}

		$db->Query($SQL_query, $result);
		$t_count = $pdb->DB_num_rows($result);
		// DB Handle
		$db->DisConnect();

		$npage = $page+1;
		$mpage = ((int)(($t_count-$t_list)/$view_count))+1;

		$buff .= "<TABLE WIDTH=100% BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
		$buff .= "<TR><TD ALIGN=right>";
		
		$start = ((int)($page/DEF_DISP_PAGE))*DEF_DISP_PAGE;
		$buf = $start+(DEF_DISP_PAGE-1);
		$maxpage = $mpage-1;

		$buff .= "Page : ";
		if($page >= 1) {
			$cpage = $page - 1;
			$buff .= "<A HREF='".$targ_php."?board=".$board."&page=".$cpage."&cmd=".$cmd."&pwd=".$pwd."&sid=".$sid."'>ڡ</A>&nbsp; ";
		}
		if ( $start >= DEF_DISP_PAGE ) {
			$bpage = $start-1;
			$bgroup = $start+1;
			if ( $bgroup > DEF_DISP_PAGE ) { $bgroup = DEF_DISP_PAGE; }
			$buff .= "<A title=\"Ƭ\" HREF='".$targ_php."?board=".$board."&page=0&cmd=".$cmd."&pwd=".$pwd."&sid=".$sid."'>&lt;&lt;</A>&nbsp; <A HREF='".$targ_php."?board=".$board."&page=".$bpage."&cmd=".$cmd."&pwd=".$pwd."&sid=".$sid."'>&lt;-$bgroup</A>&nbsp; ";
		}
		for ( $n=$start; $n<$mpage; $n++ ){
			$dn = $n+1;
			if ( $n > $buf ) {
				$agroup = $mpage - $n;
				if ( $agroup > DEF_DISP_PAGE ) { $agroup = DEF_DISP_PAGE; }
				$buff .= "&nbsp; <A HREF='".$targ_php."?board=".$board."&page=".$n."&cmd=".$cmd."&pwd=".$pwd."&sid=".$sid."'>$agroup+&gt;</A>&nbsp; <A title=\"ǽ\" HREF='".$targ_php."?board=".$board."&page=".$maxpage."&cmd=".$cmd."&pwd=".$pwd."&sid=".$sid."'>&gt;&gt;</A>";
				break;
			}

			if ( $page == $n ) {
				$buff .= "<b>[$dn]</b> ";
			} else {
				$buff .= "<A HREF='".$targ_php."?board=".$board."&page=".$n."&cmd=".$cmd."&pwd=".$pwd."&sid=".$sid."'>$dn</A> ";
			}
		}
		if ($mpage > $npage){
			$buff .= "&nbsp; <A HREF='".$targ_php."?board=".$board."&page=".$npage."&cmd=".$cmd."&pwd=".$pwd."&sid=".$sid."'>ڡ</A>\n";
		}
		$buff .= "&nbsp; ";

		$buff .= "</TD></TR></TABLE>\n";
		return $buff;

	}

	function CheckTable($targ_table) {
		$ok			= false;
		$TableData	= array();
		$targ_list	= array();
		$pdb		= new clsPipeDB();
		$db			= $pdb->DB_Connect();

		$pdb->ShowTables($db, $result);
		while ($row = $pdb->DB_fetch_row($result)) {
			$TableData[] = $row[0];
		}
		$db->DisConnect();

		$targ_list = preg_split("/<>/", $targ_table);
		
		foreach ( $targ_list as $t_table ) {
			foreach( $TableData as $val ) {
				if ( $t_table == $val ) { $ok = true; break; }
			}
		}
		return $ok;
	}

	function User_Agent() {
		$user_agent = $_SERVER['HTTP_USER_AGENT'];
		if( preg_match("/^Mozilla\/.+\(compatible\; MSIE .+\;.+\)/", $user_agent) ) {
			if( preg_match("/NetCaptor ([0-9\.]+)/", $user_agent) ) {
				$browser = 'NetCaptor';
				$browser_v = preg_replace("/NetCaptor ([0-9\.]+)/", "$1", $browser_v);
			} else if( preg_match("/Opera ([0-9\.]+)/", $user_agent) ) {
				$browser = 'Opera';
				$browser_v = preg_replace("/Opera ([0-9\.]+)/", "$1", $browser);
			} else {
				$browser = 'InternetExplorer';
				$user_agent2 = $user_agent;
				$user_agent2 = str_replace(" ", "", $user_agent2);
				$buff = preg_split ("/\;/", $user_agent2);
				$version_buff = preg_grep("/MSIE/i", $buff);
				$browser_v = $version_buff[0];
				$browser_v = str_replace("MSIE", "", $browser_v);
				if( preg_match("/^([0-9]+)\.([0-9]+)/", $browser_v) ) {
	        			$browser_v = preg_replace("/^([0-9]+)\.([0-9]+)/", "$1\.$2", $browser_v);
				}
			}

			if( preg_match("/Windows 3\.1/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = '3.1';
			} else if( preg_match("/Win32/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = '32';
			} else if( preg_match("/Windows 95/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = '95';
			} else if( preg_match("/Windows 98/i", $user_agent) ) {
				$platform = 'Windows';
				if( preg_match("/Win 9x 4\.90/", $user_agent) ) {
					$platform_v = 'Me';
				} else {
					$platform_v = '98';
				}
			} else if( preg_match("/Windows NT 5\.0/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = '2000';
			} else if( preg_match("/Windows NT 5\.1/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = 'XP';
			} else if( preg_match("/Windows NT/i", $user_agent) 
					&&  !preg_match("/Windows NT 5\.0/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = 'NT';
			} else if( preg_match("/Windows CE/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = 'CE';
			} else if( preg_match("/Mac/i", $user_agent) ) {
				$platform = 'MacOS';
				if( preg_match("/Mac_68000/i", $user_agent) ) {
					$platform_v = '68K';
				} else if( preg_match("/Mac_PowerPC/i", $user_agent) ) {
					$platform_v = 'PowerPC';
				}
			} else if( preg_match("/WebTV/i", $user_agent) ) {
				$platform = 'WebTV';
				$buff2 = str_replace(" ", "", $user_agent);
				$buff3 = str_replace("/", "", $buff2[1]);

				$platform_v = $buff3[1];
			} else {
				$platform = '';
				$platform_v = '';
			}
		} else if( preg_match("/^Mozilla\/([0-9\.]+).*\(.+\; [NIU]/", $user_agent) ) {
			$browser = 'NetscapeNavigator';
			$browser_v = preg_replace("/^Mozilla\/([0-9\.]+).*\(.+\; [NIU]/", "$1", $user_agent);

			if( preg_match("/Win95/", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = '95';
			} else if( preg_match("/Win 9x 4\.90/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = 'Me';
			} else if( preg_match("/Win98/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = '98';
			} else if( preg_match("/WinNT/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = 'NT';
			} else if( preg_match("/Windows NT 5\.0/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = '2000';
			} else if( preg_match("/Macintosh/i", $user_agent) ) {
				$platform = 'MacOS';
				if( preg_match("/68K/i", $user_agent) ) {
					$platform_v = '68K';
				} else if( preg_match("/PPC/i", $user_agent) ) {
					$platform_v = 'PowerPC';
				}
			} else if( preg_match("/SunOS/i", $user_agent) ) {
				$platform = 'SunOS';
				$buff2 = preg_split ("/\;/", $user_agent);
				$buff3 = preg_split ("/ /", $buff2[2]);
				$platform_v = $buff3[2];
			} else if( preg_match("/Linux/i", $user_agent) ) {
				$platform = 'Linux';
				$buff2 = preg_split ("/ /", $user_agent);
				$flag = 0;
				foreach ( $buff2 as $val ) {
					if($flag) {
						$platform_v = $val;
						break;
					}
					if( preg_match("/^Linux$/i", $val) ) { $flag = 1; };
				}
			} else if( preg_match("/FreeBSD/i", $user_agent) ) {
				$platform = 'FreeBSD';
				$buff2 = preg_split ("/ /", $user_agent);
				$flag = 0;
				foreach ( $buff2 as $val ) {
					if($flag) {
						$platform_v = $val;
						break;
					}
					if( preg_match("/^FreeBSD$/i", $val) ) { $flag = 1; };
				}
			} else if( preg_match("/NetBSD/i", $user_agent) ) {
				$platform = 'NetBSD';
				$platform_v = '';
			} else if( preg_match("/AIX/i", $user_agent) ) {
				$platform = 'AIX';
				$platform_v = '';
			} else if( preg_match("/IRIX/i", $user_agent) ) {
				$platform = 'IRIX';
				$buff2 = preg_split ("/ /", $user_agent);
				$flag = 0;
				foreach ( $buff2 as $val ) {
					if($flag) {
						$platform_v = $val;
						break;
					}
					if( preg_match("/^IRIX$/i", $val) ) { $flag = 1; };
				}
			} else if( preg_match("/HP-UX/i", $user_agent) ) {
				$platform = 'HP-UX';
				$platform_v = '';
			} else if( preg_match("/OSF1/i", $user_agent) ) {
				$platform = 'OSF1';
				$buff2 = preg_split ("/ /", $user_agent);
				$flag = 0;
				foreach ( $buff2 as $val ) {
					if($flag) {
						$platform_v = $val;
						break;
					}
					if( preg_match("/^OSF1$/i", $val) ) { $flag = 1; };
				}
			} else {
				$platform = '';
				$platform_v = '';
			}
		} else {
			$platform = '';
			$platform_v = '';
			$browser = '';
			$browser_v = '';
		}
		$retval = array("platform"=>$platform, "platform_v"=>$platform_v, "browser"=>$browser, "browser_v"=>$browser_v);
		return $retval;
	}

	function QuotesEntities($str) {
		$buff = $str;
		$buff = str_replace("\"", "&quot;", $buff);
		$buff = str_replace("'", "&#039;", $buff);
		return $buff;
	}

	function SetDefaultConfig() {
		global $CONFIG;

		$CONFIG['readonly']				= 0;
		$CONFIG['homepage']				= "";
		$CONFIG['bbstitle']				= DEF_ADMIN_NAME."ηǼ";
		$CONFIG['color_text']			= "#000000";
		$CONFIG['color_bg']				= "#FFFFFF";
		$CONFIG['color_link']			= "#003399";
		$CONFIG['color_subject']		= "#FFFFFF";
		$CONFIG['color_subject_bg']		= "#000050";
		$CONFIG['color_comment_text']	= "#000000";
		$CONFIG['color_comment_bg']		= "#F0F0F0";
		$CONFIG['color_em']				= "#F05C00";
		$CONFIG['color_quote']			= "#A0A020";
		$CONFIG['color_sp_fc']			= "#FFFFFF";
		$CONFIG['color_sp_bc']			= "#CC3300";
		$CONFIG['color_fin_fc']			= "#000000";
		$CONFIG['color_fin_bc']			= "#C0C0C0";
		$CONFIG['color_grn_fc']			= "#008000";
		$CONFIG['color_admin_fc']		= "#F05C00";
		$CONFIG['color_sysop_fc']		= "#0066CC";
		$CONFIG['color_uid_fc']			= "#FF0000";
		$CONFIG['color_part_fc']		= "#009080";
		$CONFIG['color_trip_fc']		= "#CC0033";
		$CONFIG['flush_time']			= 48;
		$CONFIG['viewcount']			= 20;
		$CONFIG['proxy']				= 0;	// PROXY(0:OFF1:¡2:ơ)
		$CONFIG['max_topic']			= 200;
		$CONFIG['show_topiclist']		= 1;
		$CONFIG['information']			= "ɤɤߤƤ͡";
		$CONFIG['menu_use']				= 0;
		$CONFIG['menu_name']			= "";
		$CONFIG['menu_list']			= "";
		$CONFIG['image_background']		= "";
		$CONFIG['disable']				= 0;	// ⡼
		$CONFIG['res_maxcount']			= 0;	// ƿ(0:̵)
		$CONFIG['delete_mode']			= 0;	// (0:Default1:ԤΤߡ
		$CONFIG['fin_mode']				= 1;	// λ(0:Default1:Ԥǽ)
		$CONFIG['disp_uid']				= 0;	// UIDɽѥ
		$CONFIG['mail_use']				= 0;	// ᡼εǽ(0:OFF1:ON)
		$CONFIG['scroll_arrow']			= "";	// ScrollBarο
		$CONFIG['scroll_base']			= "";	// ScrollBarBase
		$CONFIG['accept_multidata']		= 1;	// ʣǡƵĤޤǤλ(0:ʣ)
	}

}
?>
